function [hl1_n, h_n, P_n, AutoGamma] = AutoL1_RLSupdate(x_n, y_n, hl1_0, h_0, P_0, lambda, rho)

% AutoGamma is a auto-regularization factor
% output RLS and auto L1-RLS estimate
M = length(hl1_0);

Mt = P_0 * x_n;
Nom = eye(length(y_n))+x_n.' * Mt/lambda;
Kt = Mt / Nom;

     cvf = norm(hl1_0,1);
     dsf = sign(hl1_0);

alpha = trace(P_0)/M;
AutoGamma = max( 0, 2*( alpha *(cvf-rho) + dsf.'*P_0*(hl1_0-h_0))  /  ( dsf.'*P_0*P_0*dsf ) );

P_n = (P_0-Kt*x_n.'*P_0) / lambda;
hl1_n = hl1_0 +  Kt*(y_n-x_n.'*hl1_0) - AutoGamma*(1-lambda)*P_n*dsf;  % l1-BRLS
h_n = h_0 + Kt*(y_n-x_n.'*h_0); % BRLS


end