function [ch, w_n, P_n, hn, Rn, bn, pn, h1_t, h2_t, Rn1, Rn2, bn1, bn2, pn1, pn2, Q_2] = BCEupdate(lambda, gamma, epslion, c, w_0, P_0, h0, R0, b0, p0, X, Q_2, y, h, h1, h2, R1, R2, b1, b2, p1, p2, lam1, lam2,m1, m2, P)

% per pulse processing
% Output:
% the best of reults of BRLS, BSCG, GBSCG algorithms

% Note that h is true values, so nor =  X.'*h; (i.e., nor is normlized y true values)

M = length(h0);
ch = zeros(M,1); %combine estimate

%% Estimate hEst
[w_n, P_n] = RLSupdate(X, y, w_0, P_0, lambda);   % BRLS
[hn, Rn, bn, pn]  = SCGupdate(lambda, gamma, epslion, c, X, y, h0, R0, b0, p0);   % BSCG
[h_kron, h1_t, h2_t, Rn1, Rn2, bn1, bn2, pn1, pn2, Q_2] = KronSCGupdate(X, Q_2, y, h1, h2, R1, R2, b1, b2, p1, p2, lam1, lam2, gamma, epslion, c, m1, m2, P);  % KBSCG
 

     
 
      
%% Compute eta: |X\hat{h} - Xh| or Normalized eta: |X\hat{h}- Xh| / |Xh| 
     nor = X.'*h; %desired
     
     msekron = 20*log10( norm( X.'*h_kron - nor ) ./ norm(nor) );
     msescg = 20*log10( norm( X.'*hn - nor ) ./ norm(nor) );
     mserls = 20*log10( norm( X.'*w_n - nor ) ./ norm(nor) );
     
     ind =[1: m1*m2];
     H1 = reshape(h1,[m1,P]);  H2= reshape(h2,[m2,P]);
     dmsekron = 20*log10( norm ( X.'*h_kron - nor ) ./ norm(nor) ) -...
                               20*log10( norm( X(ind,:).'*kronSum( H1, H2, P ) - nor  ) ./ norm(nor) );
     dmsescg = 20*log10( norm( X.'*hn - nor ) ./ norm(nor) ) -...
                             20*log10( norm( X.'*h0 - nor ) ./ norm(nor) );
     dmserls = 20*log10( norm( X.'*w_n - nor) ./ norm(nor) ) -...
                            20*log10( norm( X.'*w_0 - nor ) ./ norm(nor) );
      
%%%%%%%%%%%%%%%%%%%%%%%%     
%      msekron = 20*log10( norm( X(ind,:).'*h_kron - y ) ./ norm(y) );
%      msescg = 20*log10( norm( X.'*hn - y ) ./ norm(y) );
%      mserls = 20*log10( norm( X.'*w_n - y ) ./ norm(y) );
%      
%      H1 = reshape(h1,[m1,P]);  H2= reshape(h2,[m2,P]);
%      dmsekron = 20*log10( norm ( X(ind,:).'*h_kron - y ) ./ norm(y) ) - 20*log10( norm( X(ind,:).'*kronSum( H1, H2, P ) -y  ) ./ norm(y) );
%      dmsescg = 20*log10( norm( X.'*hn - y ) ./ norm(y) ) - 20*log10( norm( X.'*h0 - y ) ./ norm(y) );
%      dmserls = 20*log10( norm( X.'*w_n - y) ./ norm(y) ) - 20*log10( norm( X.'*w_0 - y ) ./ norm(y) );
%%%%%%%%%%%%%%%%%%%%%%%%

% disp(['msekron=',num2str(msekron),'  msescg=',num2str(msescg),'   mserls=',num2str(mserls)])
% disp(['dmsekron=',num2str(dmsekron),'  dmsescg=',num2str(dmsescg),'   dmserls=',num2str(dmserls)])

%% 
     if (msekron <=  msescg) && (msescg <= mserls) && dmsekron < 0
           ch = h_kron;

     elseif (msekron <=  msescg) && (msescg <= mserls)
             ch = h_kron ;
             hn = h_kron;
             w_n = h_kron;
             
     elseif ((msescg <=  msekron) && (msekron <= mserls)) ||  ((msescg <= mserls ) && (mserls <= msekron)) && dmsescg<0
         
         ch = hn;     

     elseif ((msescg <=  msekron) && (msekron <= mserls)) ||  ((msescg <= mserls ) && (mserls <= msekron))
            ch = hn ;
            w_n = hn;
            
     elseif ((mserls <= msescg ) && ( msescg<= msekron)) || ((mserls <= msekron ) && ( msekron<= msescg )) && dmserls<0
         ch = w_n;
         
     else
         ch = w_n;
         hn = w_n;
        
     end
     
end









%% Function Section
function USQ_2 = UnderScore2(X, h_2,m1, m2, P)
      
%      [m2,~] = size(h_2);
%      m1 = size(X,1) / m2;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(eye(m1),h_2(:,p)) ;
             QP = [QP,Qp];
         end
         USQ_2 = QP;
             
end

function USQ_1 = UnderScore1(X, h_1, m1, m2, P)
      
%      [m1,~] = size(h_1);
%      m2 = size(X,1) / m1;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(h_1(:,p),eye(m2)) ;
             QP = [QP,Qp];
         end
         USQ_1 = QP;
             
end

function C = kronSum( A,B,P )

% return the kronecker sum of two matrix

C=[];
for p = 1:P
    
    c = kron(A(:,p),B(:,p));
    C = [C,c];
    
end
     C = sum(C,2);
end