function MSE_y =BscgMse(m1, m2, P, X, y, h, lam1,lam2, gamma, epslion, c)

 % KronBSCG Settings
h1 = zeros(m1*P,1); 
h2 = zeros(m2*P,1); 
R1 = eye(P*m1) ; R2 = eye(P*m2) ; 
b1 = zeros(P*m1,1); b2 = zeros(P*m2,1); 
p1 = zeros(P*m1,1); p2 = zeros(P*m2,1); 

Original_h2 = rand(m2,P);   %initialization h_{2}
Q_2 = UnderScore2(X, Original_h2, m1, m2, P);


[h1_t, Rn1, bn1, pn1] = SCGupdate(lam1, gamma, epslion, c, Q_2.', y, h1, R1, b1, p1);
     h1P = reshape(h1_t,[m1,P]);  
     Q_1 = UnderScore1(X, h1P, m1, m2, P);
[h2_t, Rn2, bn2, pn2] = SCGupdate(lam2, gamma, epslion, c, Q_1.', y, h2, R2, b2, p2);
     h2P =  reshape(h2_t,[m2,P]);  
     Q_2 = UnderScore2(X, h2P, m1, m2, P);

     h_kron = kronSum( h1P,h2P,P );
 
     indx = m1*m2;  %kron efficent taps
     MSE_y = 20*log10( norm( X.'*h - X(1:indx,:).'*h_kron ) ./ norm( X.'*h ) );
     
end














%% Function Section
function USQ_2 = UnderScore2(X, h_2,m1, m2, P)
      
%      [m2,~] = size(h_2);
%      m1 = size(X,1) / m2;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(eye(m1),h_2(:,p)) ;
             QP = [QP,Qp];
         end
         USQ_2 = QP;
             
end

function USQ_1 = UnderScore1(X, h_1, m1, m2, P)
      
%      [m1,~] = size(h_1);
%      m2 = size(X,1) / m1;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(h_1(:,p),eye(m2)) ;
             QP = [QP,Qp];
         end
         USQ_1 = QP;
             
end

function C = kronSum( A,B,P )

% return the kronecker sum of two matrix

C=[];
for p = 1:P
    
    c = kron(A(:,p),B(:,p));
    C = [C,c];
    
end
     C = sum(C,2);
end