function ExpPlotEstPerformance( Y0, X, Hhat )

% Here we consider estimators performance, 
% let normalized eta = |y-yhat| / |y| as performance measure.
% Note that the estimator sequence is very important.
% Hhat including cells, wherein cell includes hhat all pulses
% Y0 represents the original real data, in experiment case just as ture
% values

[L, PulseNum] = size( Y0 );
[~, EstorNum] = size(Hhat);
Eta = zeros(PulseNum , EstorNum);
for n = 1:EstorNum
    Eta(:,n) = 20*log10( vecnorm( Y0 - X'*Hhat{n} ) ./ vecnorm(Y0) );
end

figure;
plot(Eta(:,1),'-d'); hold on;%eta_rls
plot(Eta(:,2),'-*'); hold on;%eta_l1rls
plot(Eta(:,3),'-+'); hold on;%eta_ipnlms
plot(Eta(:,4),'->'); hold on;%eta_mnlms
plot(Eta(:,5),'-o'); hold on;%eta_scg
plot(Eta(:,6),'-^');hold on;%eta_scgkron
plot(Eta(:,7),'-s');%eta_C
legend('BRLS','autol1-BRLS','IPNLMS','mNLMS','BSCG','KBSCG','BCE')
xlabel('Pulse Number'); ylabel('\eta(dB)');

end