function [wn] = IPNLMSupdate(X, y, mu, w0, delta, sigma)

% sigma: control the sparse, [-1,1], note that sigma=-1, reduce to NLMS
% if sigma=1, reduce to PNLMS
% G: scaling matrix
M = length(w0);
L = length(y);


e = y - X.'*w0;
g = (1-sigma)/(2*M) +(1+sigma) * abs(w0)./(2*norm(w0,1)+10^-9);
G = diag(g);
wn = w0 + mu * G*X * inv(X.'*G*X + delta*eye(L)) * e;

end