function [h_kron, h1_t, h2_t,P_n1,P_n2,Q_2] = KronRLSupdate(X, Q_2, y, h1, h2, P_1, P_2, lam1, lam2, m1, m2, P)

%---------Kron parameters----------%
% m1=65;
% m2=12;
% P=5;

%---------Initialization parameters----------%
% USh1_rls=zeros(m1*P,PulseNum);  h1_{0}
% USh2_rls=zeros(m2*P,PulseNum);   h2_{0}
% P_n1 = eye(P*m1);
% P_n2 = eye(P*m2);
% 
% Original_h2 = rand(m2,P);   %initialization h_{2}
% USQ_2 = UnderScore2(X, Original_h2, m1, m2, P);  Q_2

%---------Output parameters----------%
% h_kron, h1_t, h2_t

     M = size(X,1);
     
     [h1_t,P_n1] = RLSupdate(Q_2.',y, h1,P_1,lam1);
     h1P = reshape(h1_t,[m1,P]);  
%      H1P = h1P;  %save estimate h_{1,p}
     Q_1 = UnderScore1(X, h1P, m1, m2, P);
     [h2_t,P_n2] = RLSupdate(Q_1.',y,h2,P_2,lam2); 
     h2P =  reshape(h2_t,[m2,P]);     
%      H2P = h2P;
     Q_2 = UnderScore2(X, h2P, m1, m2, P);

     h_kron = zeros(M,1); 
     ind =[1: m1*m2];
     h_kron(ind) = kronSum( h1P,h2P,P );
     
end



%% Function Section
function USQ_2 = UnderScore2(X, h_2,m1, m2, P)
      
%      [m2,~] = size(h_2);
%      m1 = size(X,1) / m2;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(eye(m1),h_2(:,p)) ;
             QP = [QP,Qp];
         end
         USQ_2 = QP;
             
end

function USQ_1 = UnderScore1(X, h_1, m1, m2, P)
      
%      [m1,~] = size(h_1);
%      m2 = size(X,1) / m1;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(h_1(:,p),eye(m2)) ;
             QP = [QP,Qp];
         end
         USQ_1 = QP;
             
end

function C = kronSum( A,B,P )

% return the kronecker sum of two matrix

C=[];
for p = 1:P
    
    c = kron(A(:,p),B(:,p));
    C = [C,c];
    
end
     C = sum(C,2);
end