function [w_n,P_n] = RLSupdate(x_n, y_n, w_0, P_0, lambda)

% Standard RLS update function

% x_n:= is the input vector
% y_n:= is the data sample
% P_0:= is the correlation matrix, depends on input vector x_n
% lambda:= is the forgetting factor

    Mt = P_0*x_n;
    Nom = eye(length(y_n))+x_n.' * Mt/lambda;
    Kt = Mt / Nom;
    P_n = (P_0-Kt*x_n.'*P_0) / lambda;%Pt_n1 = (Pt_n0 - Mt/Nom*Mt.') / lambda;
    w_n = w_0 + Kt*( y_n-x_n.'*w_0 );
end