function SimPlotEstPerformance( H, X, Hhat )

% H represents ture CIR values, in the Simulation case
% we know the the ture CIR, so we use |X*h - X*hhat| / |X*h|
% as performance Measure

[M, PulseNum] = size( H );
[~, EstorNum] = size(Hhat);
Eta = zeros(PulseNum , EstorNum);
for n = 1:EstorNum
    Eta(:,n) = 20*log10( vecnorm( X'*H - X'*Hhat{n} ) ./ vecnorm( X'*H ) );
end

figure;
plot(Eta(:,1),'-d'); hold on;%eta_rls
plot(Eta(:,2),'-*'); hold on;%eta_l1rls
plot(Eta(:,3),'-+'); hold on;%eta_ipnlms
plot(Eta(:,4),'->'); hold on;%eta_mnlms
plot(Eta(:,5),'-o'); hold on;%eta_scg
plot(Eta(:,6),'-^');hold on;%eta_scgkron
plot(Eta(:,7),'-s');%eta_C
legend('BRLS','autol1-BRLS','IPNLMS','mNLMS','BSCG','KBSCG','BCE')
xlabel('Pulse Number'); ylabel('\eta(dB)');

end