function st1 = TimeDelay(st,tau,fs)

% Generate new signal st1 from st with delay tau 

N = length(st);

ff = ( (1:N)'/N-.5 );
Sf = fft(st,N);
Sf1 = Sf .* exp(-1i*2*pi*ff*fs*tau);
st1 = real( ifft(Sf1,N) );


%% Example
% clear all; close all; clc;
% N  = 2500;
% fs = 5e3;
% Ts = 1/fs;
% t = (0:N-1).'*Ts;
% w = 500;  beta=50;
% st = sin(w*t) .* exp(-beta*t);  
% 
% tau = 20*Ts;
% 
% ff = ( (1:N)'/N-.5 );
% Sf = fft(st,N);
% Sf1 = Sf .* exp(-1i*2*pi*ff*fs*tau);
% st1 = ifft(Sf1,N);

