function targetS = formtargetS( Y, s, fs, dtau )

% Pretend moving target has uniform motion,
% we input the delay (dtau) then we will get the target velocity 
% and echo.

[L,PulseNum] = size( Y );
PRT = L / fs ;
c = 1500;  % underwater acoustic velocity

targetS = zeros(L,PulseNum);
for i = 1: PulseNum
    tau = 0.005+(i-1)*dtau ;          % htar delay in per pulse
    dR  = .5*2*dtau * c;    % relative distance between adjacent pulse
    v     = dR / PRT;
    DoppFactor  = 2*v / c;
    echo = [zeros(floor(tau*fs),1); resample( s, round( ( 1+DoppFactor  )*1e4 ) , 1e4  )];
    targetS(:,i) = [echo;zeros(L-length(echo),1)];
end
    

end