function [ hn, Rn, bn, pn ] = mNLMSupdate( lam, epslion, un, dn, h0, R0, b0, p0 )
   
                                                   
%  Input:
% lam:= is the forgetting factor
% epslion:= is for preventing division by zero.
% un:= is input vector
% dn:= is the data sample
% R0:= is the correlation matrix
% b0:= is the cross-correlation vector
% p0:= is the search direction

% Output:
% hn,Rn,bn,pn

Rn = lam*R0 + un*un.';
bn = lam*b0 + un*dn;
gn = Rn*h0 - bn;
Nom1 = p0.'*Rn*p0 + epslion;
betan = p0.'*Rn*gn / Nom1;
pn = -gn + p0*betan;
Nom2 = pn.'*Rn*pn + epslion;
alphan = - pn.'*gn / Nom2;
hn = h0 + pn*alphan;

end