function  WE = prewhitening( E  )

[L,num] = size(E);
WE = zeros(L,num);
for n = 1:num
    dataContainer = iddata( E(:,n) );
    Am = [1 0 1 0 1];
    Cm = [ 1 ];
    foundModel = pem( dataContainer, idpoly( Am,[],Cm ) );
%     present( foundModel );  
    WE(:,n) = filter( foundModel.A, 1, E(:,n)  ); 
%% Does the data seem to be white? More on this later.
% Is the residual white? Lets examine the Monti test.

ey = WE(:,n);

[deemedWhite, Q, chiV] = montiTest( ey );
if deemedWhite
     fprintf('The residual is deemed to be white according to the Monti-test (as %5.2f < %5.2f).\n', Q, chiV );
else
    fprintf('The residual is not deemed to be white according to the Monti-test (as %5.2f > %5.2f).\n', Q, chiV );
end

% Does the residual have a mean that is different from zero?
[ rejectH0, tRatio, tLimit ] = testMean( ey );
if rejectH0
    fprintf('The data is not deemed to be zero-mean (as %6.4f > %6.4f). \n', tRatio, tLimit )
else
    fprintf('The data is deemed to be zero-mean (as %6.4f < %6.4f). \n', tRatio, tLimit )
end

end


fprintf('pre-whitening function is over \n\n\n')
end
