%% kps: KDP Parameters Selection Simulation

% Here we use Bscgkps.m and Brlskps.m to select optimal {m1,m2,P}
% Output Fig BIC

clear all ; close all ; clc ; 

addpath('../functions','../data');

SNR = 0;%here no use
PulseNum =1;
%% Transmit Signal
Tp = 0.2;   fs = 16e3;  f1 = 3e3; f2 = 7e3;  
s = transmitLFM(Tp,fs,f1,f2);
%% Measurment Section
load 'P27_0707.mat';      h = h0707;  % true CIR

M = length(h)

for t=1:PulseNum
      h_t(:,t) = h;
      [ y_t(:,t),X ] = simulatePulseData_toeplitz(s,h_t(:,t),1,SNR);
end

%% Estimation Section
lambda = .8;
lam1 = lambda;
lam2 = lambda;

%% kpd parameters selection Section
min_m2 = 10;    % m2>=5
m1 = 30;          % m1>=10 
jishu = 1;

%% Methodkps fun.
% [opt] = Brlskps(m1, min_m2, 5, M, X, y_t(:,1), h_t(:,1), lam1,lam2)
xi = 1;    %sparse factor
delta = 1e-6;
cc = 1e-4;
% [opt] = Bscgkps(m1, min_m2, 5, M, X, y_t(:,1), h_t(:,1),  lam1,lam2, xi, delta, cc);



%% MethodMse fun.
mP=[];                                  % All m1,m2,P conbination
while m1 < M / min_m2 
  
    m2 = floor( M / m1 );
    if m1>m2
        
        m1set(jishu,:) = m1;     
        m2set(jishu,:) = m2;       
        
        c=[];
        for p=1: floor( M/(m1+m2) )
            a(p,jishu) = (m1+m2)*p;                                                                         % independent variable \Psi
            b(p,jishu) = BrlsMse(m1, m2, p, X, y_t(:,1), h_t(:,1), lam1,lam2);             % dependent variable mse using kron-BRLS
%             b(p,jishu) = BscgMse(m1, m2, p, X, y_t(:,1), h_t(:,1), lam1,lam2, gamma, epslion, cc);  % dependent variable mse using kron-BSCG
            c(:,p)=[m1;m2;p];                   
        end
        mP = [mP,c];                              % All parameters conbination
         jishu = jishu+1
         m1 = m1+(jishu-1)*5;
    else
         jishu = jishu+1
         m1 = m1+(jishu-1)*5;
         
    end

end

aa = a;
aa(find(aa==0))=[];
[Psi,ind] = sort(aa)

bb = b;
bb(find(bb==0))=[];
mse = bb(:,ind)

mP = mP(:,ind);
% save kpdC  a b mP Psi mse
%% PLOT
plot(Psi,mse,'-*');xlabel('$\Psi$','interpreter','latex');ylabel('MSE(dB)');
title('$20log10 \frac{ \Vert y-\hat{y} \Vert }{ \Vert y \Vert } $','interpreter','latex')
grid on
%%
clear all; close all; clc;
load 'kpdC.mat'
N = 4000;      %   the number of observations
z1 = -N*log(abs(mse));
z2 = Psi*log(N);  
BIC = z1+z2;    %BIC curve

% BIC should ȡ

% figure; plot(Psi,mse,'-*');xlabel('$\Psi$','interpreter','latex');ylabel('MSE(dB)'); grid on
figure;plot(Psi,-log(BIC),'-*');xlabel('\Psi');ylabel('BIC'); grid on

figure;
subplot(3,1,1); plot( Psi,z1 ,'-o');  xlabel('\Psi');  title(['N*log( mse(Psi) ),  N=',num2str(N)]); 
subplot(3,1,2); plot( Psi,z2 ,'-^');  xlabel('\Psi');   title('Psi*log(N)')
subplot(3,1,3); plot( Psi, -log(BIC) ,'-*');  xlabel('\Psi');   title('BIC ( Psi ) = N*log(mse( Psi )) + Psi*log( N )')


[~,qc] = find(BIC==min(BIC))
mP(:,qc)
mse(:,qc)

