% Similar to Demo_kps_5cSNR,  In this experiment only changing lambda

clear all ; close all ; clc ; 

addpath('../functions','../data');

Part = 2;% time-varying part
partnum = 40;% CIRs in one part, and all CIRs are time-invariant
PulseNum = partnum*Part;

tic

SNR = 0;

%% Transmit Signal
Tp = 0.2;   fs = 16e3;  f1 = 3e3; f2 = 7e3;  
s = transmitLFM(Tp,fs,f1,f2);
%% Measurment Section
load 'P27_0707.mat';     h = h0707;  % true CIR
% load 'Sparseh';   h = sh;

M = length(h)

w = envelope ( h );
for part = 1:Part
    Delta_h(:,part) =  w.*randn(M,1);
    for  t = partnum*(part-1)+1 : partnum*part
        h_t(:,t) = h + Delta_h(:,part);
        [ cali_y(:,t) , X ] = simulatePulseData_toeplitz(s,h_t(:,t),1,SNR);
    end
end

%%%%%%%%
% figure;
% plot(h_t(:,10)); hold on;
% plot(h_t(:,50));hold on
% legend('$h_{part1}$','$h_{part2}$','interpreter','latex')
%%%%%%%%%%
%% Estimatie Section

%% lam selection START
for i=1:6

    lambda = 1 - ( i-1 )*.1;

 %% BRLS Settings
h_rls = zeros(M,PulseNum);
P_n = eye(M);
%% KBRLS Settings
m1 = 65;    m2 = 12;      P = 5;
h1_rls=zeros(m1*P,PulseNum);
h2_rls=zeros(m2*P,PulseNum);
P_n1 = eye(P*m1);
P_n2 = eye(P*m2);
Original_h2rls = rand(m2,P);   %initialization h_{2}
Q_2rls = UnderScore2(X, Original_h2rls, m1, m2, P);
%% auto l1-BRLS Settings
rho1 = round (norm(h/max(abs(h)),1) );

h_l1rls = zeros(M,PulseNum);  % l1-BRLS
htmp = zeros(M,PulseNum); 
P_nl1 = eye(M);      
%% mNLMS Settings
 delta = 1e-6;
 h_mnlms = zeros(M,PulseNum);
 
 R =  eye(M) ; 
 b = zeros(M,1); 
 p = zeros(M,1); 
%% IPNLMS Settings
h_ipnlms = zeros(M,PulseNum); 
sigma = 0.99;
delta = 10^-6;
mu = 0.7;
 %% BSCG Settings
xi = .7;    %sparse factor
delta = 1e-6;
c = 1e-4;

h_scg = zeros(M,PulseNum); 
Rn = eye(M) ; 
bn = zeros(M,1); 
pn = zeros(M,1); 
 %% KBSCG Settings
m1 = 65;    m2 = 12;      P = 5;
h1_scg = zeros(m1*P,PulseNum); 
h2_scg = zeros(m2*P,PulseNum); 
Rn1 = eye(P*m1) ; Rn2 = eye(P*m2) ; 
bn1 = zeros(P*m1,1); bn2 = zeros(P*m2,1); 
pn1 = zeros(P*m1,1); pn2 = zeros(P*m2,1); 

Original_h2scg = rand(m2,P);   %initialization h_{2}
Q_2scg = UnderScore2(X, Original_h2scg, m1, m2, P);
%% BCE Settings
m1 = 65;    m2 = 12;      P = 5;
w_c = zeros(M,PulseNum);
P_c = eye(M);

h_c = zeros(M,PulseNum); 
Rnc = eye(M) ; 
bnc = zeros(M,1); 
pnc = zeros(M,1); 
h1_c = zeros(m1*P,PulseNum); 
h2_c = zeros(m2*P,PulseNum); 
Rnc1 = eye(P*m1) ; Rnc2 = eye(P*m2) ; 
bnc1 = zeros(P*m1,1); bnc2 = zeros(P*m2,1); 
pnc1 = zeros(P*m1,1); pnc2 = zeros(P*m2,1); 

Original_h2c = rand(m2,P);   %initialization h_{2}
Q_2c = UnderScore2(X, Original_h2c, m1, m2, P);

%% LOOP
for t = 1:PulseNum
     yb = cali_y(:,t);
     
      %% BRLS loop
      [h_rls(:,t+1),P_n] = RLSupdate(X, yb, h_rls(:,t), P_n, lambda);
      %% KBRLS loop
      [h_rlskron(:,t), h1_rls(:,t+1), h2_rls(:,t+1), P_n1, P_n2, Q_2rls] = KronRLSupdate(X, Q_2rls, yb, h1_rls(:,t), h2_rls(:,t), P_n1, P_n2, lambda, lambda, m1, m2, P);    
      %% auto l1-BRLS loop
      [h_l1rls(:,t+1), htmp(:,t+1), P_nl1, gml1(t)] = AutoL1_RLSupdate(X, yb, h_l1rls(:,t), htmp(:,t), P_nl1, lambda, rho1);
      %% mNLMS loop
        [ h_mnlms(:,t+1), R, b, p ] = mNLMSupdate( lambda, delta, X, yb, h_mnlms(:,t), R, b, p );
      %% IPNLMS loop
      [h_ipnlms(:,t+1)] = IPNLMSupdate(X, yb, mu, h_ipnlms(:,t), delta, sigma);      
      %% BSCG loop
      [h_scg(:,t+1),Rn,bn,pn] = SCGupdate(lambda, xi, delta, c, X, yb, h_scg(:,t), Rn, bn, pn);
      %% KBSCG loop
      [h_scgkron(:,t), h1_scg(:,t+1), h2_scg(:,t+1), Rn1, Rn2, bn1, bn2, pn1, pn2, Q_2scg] = KronSCGupdate(X, Q_2scg, yb, h1_scg(:,t), h2_scg(:,t), Rn1, Rn2, bn1, bn2, pn1, pn2, lambda, lambda, xi, delta, c, m1, m2, P) ;
      %% BCE loop
      [h_C(:,t), w_c(:,t+1), P_c, h_c(:,t+1), Rnc, bnc, pnc, h1_c(:,t+1), h2_c(:,t+1), Rnc1, Rnc2, bnc1, bnc2, pnc1, pnc2, Q_2c] =...
                            BCEupdate(lambda, xi, delta, c, w_c(:,t), P_c, h_c(:,t), Rnc, bnc, pnc,...
                                               X, Q_2c, yb, h_t(:,t), ...
                                               h1_c(:,t), h2_c(:,t), Rnc1, Rnc2, bnc1, bnc2, pnc1, pnc2, lambda, lambda, m1, m2, P);
 
       disp(['pulse=',num2str(t)])
end
%% output hEst
h_rls = h_rls(:,2:end);
h_l1rls = h_l1rls(:,2:end);
h_mnlms = h_mnlms(:,2:end);
h_scg = h_scg(:,2:end);
h_ipnlms = h_ipnlms(:,2:end);

%% Plot Performance Measure  eta
eta_rls = 20*log10( vecnorm( X.'*h_t  - X.'* h_rls ) ./ vecnorm( X.'*h_t ) ); 
eta_autol1rls = 20*log10( vecnorm( X.'*h_t  - X.'* h_l1rls ) ./ vecnorm( X.'*h_t ) ); 
eta_mnlms = 20*log10( vecnorm( X.'*h_t  - X.'* h_mnlms ) ./ vecnorm( X.'*h_t ) ); 
eta_ipnlms = 20*log10( vecnorm( X.'*h_t  - X.'* h_ipnlms ) ./ vecnorm( X.'*h_t) ); 
eta_scg = 20*log10( vecnorm( X.'*h_t  - X.'* h_scg ) ./ vecnorm( X.'*h_t) ); 
eta_scgkron = 20*log10( vecnorm( X.'*h_t  - X.'* h_scgkron ) ./ vecnorm( X.'*h_t  ) ); 
eta_C=  20*log10( vecnorm( X.'*h_t - X.'*h_C ) ./ vecnorm( X.'*h_t  ) ); 

%% Plot Performance Measure  MSD
MSD_rls = 20*log10( vecnorm( h_t  - h_rls ) ./ vecnorm( h_t ) ); 
MSD_autol1rls = 20*log10( vecnorm( h_t  -  h_l1rls ) ./ vecnorm( h_t ) ); 
MSD_mnlms = 20*log10( vecnorm( h_t  - h_mnlms ) ./ vecnorm( h_t ) ); 
MSD_ipnlms = 20*log10( vecnorm( h_t  - h_ipnlms ) ./ vecnorm( h_t ) ); 
MSD_scg = 20*log10( vecnorm( h_t  -  h_scg ) ./ vecnorm( h_t ) ); 
MSD_scgkron = 20*log10( vecnorm( h_t  -  h_scgkron ) ./ vecnorm( h_t  ) ); 
MSD_C=  20*log10( vecnorm( h_t - h_C ) ./ vecnorm( h_t  ) ); 

%% Compute average eta (use steady state)
clearvars Peta_rls Peta_autol1rls Peta_mnlms Peta_ipnlms Peta_scg Peta_scgkron Peta_C 

for part =1: Part  % 
    usepart = (part-1)*partnum+5:part*partnum ; % steady state part
    Peta_rls(part) = mean( eta_rls( :, usepart ) ); % every part average of effcial eta
    Peta_autol1rls(part) = mean( eta_autol1rls( :, usepart ) );
    Peta_mnlms(part) = mean( eta_mnlms( :, usepart ) );
    Peta_ipnlms (part) = mean( eta_ipnlms ( :, usepart ) );
    Peta_scg (part) = mean( eta_scg ( :, usepart ) );
    Peta_scgkron (part) = mean( eta_scgkron ( :, usepart ) );
    Peta_C (part) = mean( eta_C ( :, usepart ) );
end

Meta_rls(:,i) = mean(Peta_rls); % output average eta on one SNR case
Meta_autol1rls(:,i) = mean(Peta_autol1rls); 
Meta_mnlms(:,i) = mean(Peta_mnlms); 
Meta_ipnlms(:,i) = mean(Peta_ipnlms); 
Meta_scg (:,i) = mean(Peta_scg ); 
Meta_scgkron (:,i) = mean(Peta_scgkron ); 
Meta_C (:,i) = mean(Peta_C ); 

end

%% Plot Effect of lambda on eta
figure;
lam = [1:-.1:.5];
plot(lam, Meta_rls,'-o');hold on;
plot(lam, Meta_autol1rls,'-+');hold on;
plot(lam, Meta_mnlms,'-^');hold on;
plot(lam, Meta_ipnlms,'-*');hold on;
plot(lam, Meta_scg,'--^');hold on;
plot(lam,Meta_scgkron,'--+');hold on;
plot(lam,Meta_C,'--o');
legend('BRLS','autol1-BRLS','mNLMS','IPNLMS','BSCG','GBSCG','BCE');
xlabel('\lambda'); ylabel('\eta(dB)');
title(['SNR=',num2str(SNR),'   \xi=',num2str(xi),'  \eta_{y}  '])

time = toc

%% paper fig7
open('eta_lam.fig');




%%
% Tp = 0.2;   fs = 16e3;  f1 = 3e3; f2 = 7e3;  
% s = transmitLFM(Tp,fs,f1,f2);
% 
% SNR = 0;
% PulseNum = 80;
% %% Measurment Section
% load 'P27_0707.mat';
% h = h0707;  % true CIR
% 
% M = length(h)
% 
% w = envelope ( h );
% for part = 1:2
%     Delta_h(:,part) =  w.*randn(M,1);
%     for  t = 40*(part-1)+1 : 40*part
%         h_t(:,t) = h + Delta_h(:,part);
%         [ cali_y(:,t) , X ] = simulatePulseData_toeplitz(s,h_t(:,t),1,SNR);
%     end
% end
% 
% 
% 
% %% Estimatie Section
% m1 =  65;
% m2 = 12;
% P = 5;
% 
% %--------lambda selection START--------%
% for i=1:6
% lambda = 1 - ( i-1 )*.1
% lam1=lambda;
% lam2=lambda;
% %--------lambda selection END--------% 
% 
% % lambda = .7;
% % lam1=lambda;
% % lam2=lambda;
% 
% 
% Outh = zeros(M,PulseNum);
% 
%  % BRLS Settings
% h_rls = zeros(M,PulseNum);
% P_n = eye(M);
% % KronBRLS Settings
% h1_rls=zeros(m1*P,PulseNum);
% h2_rls=zeros(m2*P,PulseNum);
% P_n1 = eye(P*m1);
% P_n2 = eye(P*m2);
% 
%  % BSCG Settings
% gamma = 0.7;    %sparse factor
% epslion = 1e-4;
% c = 0.0001;
% 
% h_scg = zeros(M,PulseNum); 
% Rn = eye(M) ; 
% bn = zeros(M,1); 
% pn = zeros(M,1); 
%  % KronBSCG Settings
% h1_scg = zeros(m1*P,PulseNum); 
% h2_scg = zeros(m2*P,PulseNum); 
% Rn1 = eye(P*m1) ; Rn2 = eye(P*m2) ; 
% bn1 = zeros(P*m1,1); bn2 = zeros(P*m2,1); 
% pn1 = zeros(P*m1,1); pn2 = zeros(P*m2,1); 
% 
% % Combine Setting
% w_c = zeros(M,PulseNum);
% P_c = eye(M);
% 
% h_c = zeros(M,PulseNum); 
% Rnc = eye(M) ; 
% bnc = zeros(M,1); 
% pnc = zeros(M,1); 
% 
% h1_c = zeros(m1*P,PulseNum); 
% h2_c = zeros(m2*P,PulseNum); 
% Rnc1 = eye(P*m1) ; Rnc2 = eye(P*m2) ; 
% bnc1 = zeros(P*m1,1); bnc2 = zeros(P*m2,1); 
% pnc1 = zeros(P*m1,1); pnc2 = zeros(P*m2,1); 
% 
% %----------initialization h_{2}-------------------%
% Original_h2rls = rand(m2,P);   %initialization h_{2}
% Original_h2scg = rand(m2,P);   %initialization h_{2}
% Original_h2c = rand(m2,P);   %initialization h_{2}
% Q_2rls = UnderScore2(X, Original_h2rls, m1, m2, P);
% Q_2scg = UnderScore2(X, Original_h2scg, m1, m2, P);
% Q_2c = UnderScore2(X, Original_h2c, m1, m2, P);
% 
% for t = 1:PulseNum
%      yb = cali_y(:,t);
%     
%       [h_rls(:,t+1),P_n] = RLSupdate(X, yb, h_rls(:,t), P_n, lambda);
%       [h_rlskron(:,t), h1_rls(:,t+1), h2_rls(:,t+1), P_n1, P_n2, Q_2rls] = KronRLSupdate(X, Q_2rls, yb, h1_rls(:,t), h2_rls(:,t), P_n1, P_n2, lam1, lam2, m1, m2, P);
%       [h_scg(:,t+1),Rn,bn,pn] = SCGupdate(lambda, gamma, epslion, c, X, yb, h_scg(:,t), Rn, bn, pn);
%       [h_scgkron(:,t), h1_scg(:,t+1), h2_scg(:,t+1), Rn1, Rn2, bn1, bn2, pn1, pn2, Q_2scg] = KronSCGupdate(X, Q_2scg, yb, h1_scg(:,t), h2_scg(:,t), Rn1, Rn2, bn1, bn2, pn1, pn2, lam1, lam2, gamma, epslion, c, m1, m2, P) ;
% 
% 
%       [h_C(:,t), w_c(:,t+1), P_c, h_c(:,t+1), Rnc, bnc, pnc, h1_c(:,t+1), h2_c(:,t+1), Rnc1, Rnc2, bnc1, bnc2, pnc1, pnc2, Q_2c] =...
%                             BCEupdate(lambda, gamma, epslion, c, w_c(:,t), P_c, h_c(:,t), Rnc, bnc, pnc,...
%                                                X, Q_2c, yb, h_t(:,t), ...
%                                                h1_c(:,t), h2_c(:,t), Rnc1, Rnc2, bnc1, bnc2, pnc1, pnc2, lam1, lam2, m1, m2, P);
%  
% end
% 
% h_rls = h_rls(:,2:end);
% h_scg = h_scg(:,2:end);
% 
% maxind = m1*m2;            % effective dictionary column, effect X, h_t
% ind = [1:maxind];  % selected effecient taps, effecient column of X 
% jj = ind;
% 
% 
% mse_rls = 20*log10( vecnorm( X.'*  h_t - X.'*h_rls ) ./ vecnorm( X.'*  h_t ) );  
% mse_scg = 20*log10( vecnorm( X.'*  h_t  - X.'*h_scg ) ./ vecnorm( X.'*  h_t ) );    
% mse_rlskron = 20*log10( vecnorm( X.'*  h_t  - X(jj,:).'*h_rlskron(jj,:)  ) ./ vecnorm( X.'*  h_t  ) );       % kpd-Brls mse
% mse_scgkron = 20*log10( vecnorm( X.'*  h_t  - X(jj,:).'*h_scgkron(jj,:) ) ./ vecnorm( X.'*  h_t  ) ); 
% mse_C = 20*log10( vecnorm( X.'*  h_t  - X.'*h_C ) ./ vecnorm( X.'*  h_t ) );   
% %%  compute average mse
% % avemse_rls(i,:) = mean(mse_rls);
% % avemse_scg(i,:)  = mean(mse_scg);
% % avemse_rlskron(i,:)  = mean(mse_rlskron);
% % avemse_scgkron(i,:)  = mean(mse_scgkron);
% 
% %%  compute \eta
% clearvars mse_rlsSumPart mse_scgSumPart mse_rlskronSumPart mse_scgkronSumPart  mse_CSumPart  eta 
% for part = 1:2
%     mse_rlsSumPart (part,:) = mean( mse_rls( :, (part-1)*40+5:part*40 ) );
%     mse_scgSumPart (part,:) = mean( mse_scg( :, (part-1)*40+5:part*40 ) );
%     mse_rlskronSumPart (part,:) = mean( mse_rlskron( :, (part-1)*40+5:part*40 ) );
%     mse_scgkronSumPart (part,:) = mean( mse_scgkron( :, (part-1)*40+5:part*40 ) );
%     mse_CSumPart  (part,:) = mean( mse_C( :, (part-1)*40+5:part*40 ) );
% end
%  
% 
% eta_rls(:,i) = mean( mse_rlsSumPart ) ;
% eta_scg(:,i) = mean( mse_scgSumPart ) ;
% eta_rlskron(:,i) = mean( mse_rlskronSumPart ) ;
% eta_scgkron(:,i) = mean( mse_scgkronSumPart ) ;
% eta_C(:,i) = mean( mse_CSumPart ) ;
% 
% end
% 
% 
% %% PLOT
% 
% lam = [1:-.1:.5];
% plot(lam,eta_rls,'-o');hold on;
% plot(lam,eta_scg,'-^');hold on;
% % plot(lam,eta_rlskron,'--o');hold on;
% plot(lam,eta_scgkron,'--o');hold on;
% plot(lam,eta_C,'--^');
% legend('BRLS','BSCG','GBSCG','BCE');
% xlabel('\lambda'); ylabel('\eta(dB)');
% title(['SNR=',num2str(SNR),'   \eta  ']);













%% Function Section
function USQ_2 = UnderScore2(X, h_2,m1, m2, P)
      
%      [m2,~] = size(h_2);
%      m1 = size(X,1) / m2;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(eye(m1),h_2(:,p)) ;
             QP = [QP,Qp];
         end
         USQ_2 = QP;
             
end

function USQ_1 = UnderScore1(X, h_1, m1, m2, P)
      
%      [m1,~] = size(h_1);
%      m2 = size(X,1) / m1;
ind = m1*m2;
     
     QP=[];
         for p=1:P
             Qp =  X(1:ind,:).'*kron(h_1(:,p),eye(m2)) ;
             QP = [QP,Qp];
         end
         USQ_1 = QP;
             
end

function C = kronSum( A,B,P )

% return the kronecker sum of two matrix

C=[];
for p = 1:P
    
    c = kron(A(:,p),B(:,p));
    C = [C,c];
    
end
     C = sum(C,2);
end