function outputT = SimAMFD( Y, X, Hhat, initialK, s )

% This function output detection variable, we use different estimators to
% remove channel effect using the residual to detect the weak moving
% target, futhermore, we correct 'T' to '\tildeT' through correlation peak
% technique (DriftEstimator_Xcorr.m), exploiting the moving characteristic.
%
% initialK: target occur pulse
% Hhat: estiamted channel using estimators


fs = 16e3;

%% No consider CIR matchfilter
y = Y(:,initialK:end);                                          %matrix y(k)
mfT = formDetectionVariable1( y, s );             %matrix  T(yk)  
% mftT = DriftEstimator_Xcorr( mfT ); 
% mfbT = sum( mftT,2 );
outputmfT = max( sum(mfT,2) );
yk   = mean( y ,2 );    
%

%% Consider CIR matchfilter
[~, EstorNum] = size(Hhat);
for n = 1:EstorNum
    
        e   = Y(:,initialK:end) - X'*Hhat{n}(:,initialK-1:end-1);   %residual matrix, for caseB: moving target being present in all pulse
        T = formDetectionVariable1( e, s );          %detection variable
        Cz = DriftEstimator_Xcorr( T );                  %correct detection variable, \tildeT
        bT = sum( Cz,2 );                                       %improved detection variable, \breveT
        outputestT(n) = max(bT);        
               
        % Save for Plot
        ek(:,n) = mean( e,2 );                  % save mean residual of estimators
        E{n} = e;                                     % save residual of estimators
        estT{n} = T;                                % save detection variable 'T' of estimators
        tT{n} = Cz;                                  % save corrected detection variable '\tildeT' of estimators
        BT(:,n) = bT;                                % save improved detection variable '\breveT' of estimators
        
end

outputT = [ outputestT,outputmfT ];


%% Check residual  Normal & White
% fprintf('There is %d estimators \n',(EstorNum));
% fprintf('The sequence is BRLS, autol1-BRLS, IPNLMS, mNLMS, BSCG, KBSCG, BCE \n')
% 
% checkIfNormal( ek, 'residual' )
% checkIfWhite( ek )
% checkIfWhite( yk )

%%
% # plot \Breve{T}_K, 
[N,~] = size(T);
figure;
plot( (1:N)/fs, BT , '--.', 'LineWidth',1  ); hold on;
plot( (1:N)/fs, sum( mfT , 2 ),  '-', 'LineWidth',1.5 );        
legend('BRLS','autol1-BRLS','IPNLMS','mNLMS','BSCG','KBSCG','BCE','UMF');
xlabel('Time(s)');ylabel('$\breve{T}_K$','Interpreter','latex');
% title('$Calibrated \sum T(k)$, where e(k)= y(k) - X*h(k-1)','interpreter','latex');    %ylim([0 30])

% # refineplot T, \tildeT, \breveT

nn = 7; %estimator number
figure;
subplot(311), plot( (1:N)/fs, estT{nn} ); xlabel('Time(s)'), ylabel('$T$','Interpreter','latex'); 
subplot(312), plot( (1:N)/fs, tT{nn} ); xlabel('Time(s)'), ylabel('$\tilde{T}$','Interpreter','latex'); 
subplot(313), plot( (1:N)/fs, BT(:,nn) ); xlabel('Time(s)'), ylabel('$\breve{T}$','Interpreter','latex'); 


fprintf('SimAMFD ( Augmented Median Filter Detector ) function is over  \n')
end